Robotsystem of the Robot Group Leipzig: ComplexMeasure Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ComplexMeasure Class Reference

`#include <complexmeasure.h>`

Inherits AbstractMeasure.

Inherited by TrackableMeasure.

Inheritance diagram for ComplexMeasure:

[legend]
Collaboration diagram for ComplexMeasure:

[legend]
List of all members.

## Public Member Functions
| ComplexMeasure (const char *measureName, ComplexMeasureMode mode, int numberBins)
| creates a new complex measure.
virtual void | addObservable (double &observedValue, double minValue, double maxValue)
| adds a observed variable to the measure.
virtual | ~ComplexMeasure ()
virtual void | step ()
| defined by AbstractMeasure.
## Protected Member Functions
void | calculatePInf ()
| calculates the Predictive Information
void | updateEntropy (int binNumber)
| updates the entropy.
void | computeEntropy ()
| computes the entropy.
void | initF ()
| inits F, neccessary after each call of addObservable()
## Protected Attributes
std::list< double * > | observedValueList
std::list< Discretisizer * > | discretisizerList
ComplexMeasureMode | mode
int | numberBins
int | fSize
int | historySize
int * | F
int * | binNumberHistory
int | historyIndex
int * | historyIndexList
int | historyIndexNumber
int | historyInterval

## Constructor & Destructor Documentation

ComplexMeasure | ( | const char * | measureName,
|  | ComplexMeasureMode | mode,
|  | int | numberBins |
| ) |  |  |

creates a new complex measure.

the calculated things are such like mutual information, entropy, joint entropy and so on. it`s possible to add new ones, see above for the ComplexMeasureModes. Don"t forget! to add observed values! with the method

See also:
  addObservable

Parameters:

  | measureName | the name of the measure, needed for PlotOptions and HUDSM
  | mode | the measure you like to have
  | numberBins | in earlier versions named as intervalCount. For complex measures the observedValue has to be discretisized, this does the ComplexMeasure with the class Discretisizer for you.

~ComplexMeasure | ( |  | ) | `[virtual]`

## Member Function Documentation

void addObservable | ( | double & | observedValue,
|  | double | minValue,
|  | double | maxValue |
| ) |  |  | `[virtual]`

adds a observed variable to the measure.

Parameters:

  | observedValue | address of the observed value
  | minValue | minimum value the observed value can become
  | maxValue | maximum value the observed value can become

void calculatePInf | ( |  | ) | `[protected]`

calculates the Predictive Information

void computeEntropy | ( |  | ) | `[protected]`

computes the entropy.

uses the normal rule with O(m*n*o) costs

void initF | ( |  | ) | `[protected]`

inits F, neccessary after each call of addObservable()

void step | ( |  | ) | `[virtual]`

defined by AbstractMeasure.

This method is called from StatisticTools for updating the measure in every simStep (ODE).

Implements AbstractMeasure.

Reimplemented in TrackableMeasure.

void updateEntropy | ( | int | binNumber | ) | `[protected]`

updates the entropy.

uses update rule with O(1) costs

Parameters:

  | binNumber | the bin number

## Member Data Documentation

int* binNumberHistory`[protected]`

std::list<Discretisizer*> discretisizerList`[protected]`

int* F`[protected]`

int fSize`[protected]`

int historyIndex`[protected]`

int* historyIndexList`[protected]`

int historyIndexNumber`[protected]`

int historyInterval`[protected]`

int historySize`[protected]`

ComplexMeasureMode mode`[protected]`

int numberBins`[protected]`

std::list<double*> observedValueList`[protected]`

The documentation for this class was generated from the following files:

- complexmeasure.h
- complexmeasure.cpp